# encoding: utf-8
require "logstash/codecs/base"
require "logstash/codecs/line"
require "influxparser"
# Add any asciidoc formatted documentation here
class LogStash::Codecs::Influxdb < LogStash::Codecs::Base

  # input {
  #   stdin { codec => influxdb { } }
  # }
  #
  # or
  #
  # output {
  #   stdout { codec => influxdb { } }
  # }
  config_name "influxdb"

  # Append a string to the message
  config :append, :validate => :string, :default => ', Hello World!'

  public
  def register
    @lines = LogStash::Codecs::Line.new
    @lines.charset = "UTF-8"
  end

  public
  def decode(data)
    @lines.decode(data) do |line|
      # replace = { "message" => line.get("message").to_s + @append }
      # yield LogStash::Event.new(replace)
      yield LogStash::Event.new(InfluxParser.parse_point(line.get("message")))
    end
  end # def decode

  public
  def encode(event)
    # @on_event.call(event, event.get("message").to_s + @append + NL)
    # there is no encode (maybe some day)
    yield event
  end # def encode

end # class LogStash::Codecs::Influxdb